"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactCodemirror = _interopRequireDefault(require("@uiw/react-codemirror"));
var _copyToClipboard = _interopRequireDefault(require("@uiw/copy-to-clipboard"));
var _langJavascript = require("@codemirror/lang-javascript");
var _reactSplit = _interopRequireDefault(require("@uiw/react-split"));
var _ThirdPartyButton = _interopRequireDefault(require("./ThirdPartyButton"));
var icon = _interopRequireWildcard(require("./icon"));
var _ErrorMessage = require("./ErrorMessage");
var _useCodePreview = require("./useCodePreview");
var _jsxRuntime = require("react/jsx-runtime");
const CodePreview = /*#__PURE__*/_react.default.forwardRef((props, ref) => {
  const {
    style,
    prefixCls = 'w-code-preview',
    className,
    theme = 'light',
    editProps = {},
    codePenOption,
    codeSandboxOption,
    code: _Code = '',
    dependencies = {},
    btnText = 'Code',
    btnHideText = 'Hide Editor',
    onlyEdit = false,
    bordered = true,
    noCode = false,
    noPreview = false,
    noScroll = false,
    bgWhite = false,
    ...otherProps
  } = props;
  const {
    playerId,
    setDemoDom,
    code,
    setCode,
    fullScreen,
    setFullScreen,
    errorMessage,
    width,
    setWidth,
    showEdit,
    setShowEdit,
    copied,
    setCopied
  } = (0, _useCodePreview.useCodePreview)({
    code: _Code,
    dependencies,
    ...props
  });
  const demoRef = (0, _react.useRef)(null);
  const editor = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, () => ({
    editor: editor,
    demo: demoRef.current
  }), [editor, demoRef]);
  const isOneItem = !noCode && !noPreview ? false : !noCode || !noPreview;
  const visiable = width === 1 ? false : [isOneItem ? 1 : 2];
  const cls = [className, prefixCls, noScroll ? "".concat(prefixCls, "-noScroll") : null, isOneItem ? "".concat(prefixCls, "-OneItem") : null, bordered ? "".concat(prefixCls, "-bordered") : null, fullScreen ? "".concat(prefixCls, "-fullScreen") : null].filter(Boolean).join(' ').trim();
  // eslint-disable-next-line react-hooks/exhaustive-deps
  (0, _react.useEffect)(() => setCode(_Code), [_Code]);
  (0, _react.useEffect)(() => {
    if (demoRef.current) {
      setDemoDom(demoRef.current);
    }
    window.addEventListener('popstate', e => {
      document.body.style.overflow = 'inherit';
    }, false);
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  const transitionend = () => setShowEdit(width !== 1);
  (0, _react.useEffect)(() => {
    const dom = demoRef.current;
    if (dom) {
      dom.addEventListener('transitionend', transitionend);
    }
    return () => {
      if (dom) {
        dom.removeEventListener('transitionend', transitionend);
      }
    };
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [width]);
  const handleChange = (value, viewUpdate) => {
    setCode(value);
    if (editProps && editProps.onChange) {
      editProps.onChange(value, viewUpdate);
    }
  };
  const onSwitchSource = () => {
    setWidth(width === 1 ? '50%' : 1);
    setShowEdit(true);
  };
  const onCopyCode = () => {
    (0, _copyToClipboard.default)(code || '', isCopy => setCopied(isCopy));
    setTimeout(() => setCopied(false), 2000);
  };
  const onFullScreen = () => {
    setFullScreen(!fullScreen);
    document.body.style.overflow = !fullScreen ? 'hidden' : 'inherit';
    if (!fullScreen && demoRef.current) {
      demoRef.current.style.maxWidth = 'inherit';
    }
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_reactSplit.default, {
    "data-color-mode": theme,
    visiable: visiable,
    className: cls,
    style: {
      flex: 1,
      ...style
    },
    ...otherProps,
    children: [!noPreview && !onlyEdit && /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: ["".concat(prefixCls, "-demo"), !bgWhite ? "".concat(prefixCls, "-demo-bgPlaid") : null, errorMessage ? "".concat(prefixCls, "-demo-error") : null].filter(Boolean).join(' ').trim(),
      style: {
        flex: 1,
        ...(width === 1 ? {
          width: '100%'
        } : {})
      },
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_ErrorMessage.ErrorMessage, {
        message: errorMessage
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ["".concat(prefixCls, "-demo-source"), errorMessage ? 'error' : null].filter(Boolean).join(' ').trim(),
        id: playerId.current
      })]
    }), (!noCode || onlyEdit) && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      ref: demoRef,
      style: {
        overflow: 'hidden',
        width: onlyEdit ? '100%' : width
      },
      children: (showEdit || onlyEdit) && /*#__PURE__*/(0, _jsxRuntime.jsx)(_reactCodemirror.default, {
        value: (code || '').replace(/\n$/, ''),
        ref: editor,
        theme: theme,
        extensions: [(0, _langJavascript.javascript)({
          jsx: true
        })],
        ...editProps,
        style: {
          height: '100%'
        },
        height: "100%",
        onChange: handleChange
      })
    }), !isOneItem && !(noCode && noPreview) && !onlyEdit && /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      style: {
        flex: 1,
        width: 29
      },
      className: "".concat(prefixCls, "-bar"),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_ThirdPartyButton.default, {
        prefixCls: prefixCls,
        codePenOption: codePenOption,
        codeSandboxOption: codeSandboxOption
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: "".concat(prefixCls, "-bar-btn"),
        onClick: onSwitchSource,
        children: width === 1 ? btnText : btnHideText
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ["".concat(prefixCls, "-bar-iconbtns"), copied ? "".concat(prefixCls, "-bar-copied") : null].filter(Boolean).join(' ').trim(),
        onClick: onCopyCode,
        children: copied ? icon.copyOk : icon.copy
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ["".concat(prefixCls, "-bar-iconbtns"), fullScreen ? "".concat(prefixCls, "-bar-copied") : null].filter(Boolean).join(' ').trim(),
        onClick: onFullScreen,
        children: icon.full
      })]
    })]
  });
});
CodePreview.displayName = 'CodePreview';
var _default = exports.default = CodePreview;
module.exports = exports.default;